package com.gxzc.zen.common.config.jackson

import com.fasterxml.jackson.core.JsonParser
import com.fasterxml.jackson.databind.DeserializationContext
import com.fasterxml.jackson.databind.JsonDeserializer
import org.slf4j.LoggerFactory

/**
 * String -> Long
 * @author NorthLan
 * @date 2018/5/15
 * @url https://noahlan.com
 */
class LongJsonDeserializer : JsonDeserializer<Long>() {
    companion object {
        private val logger = LoggerFactory.getLogger(LongJsonDeserializer::class.java)
    }

    override fun deserialize(p: JsonParser?, ctxt: DeserializationContext?): Long? {
        val value = p?.text
        return try {
            value?.toLong()
        } catch (e: NumberFormatException) {
            logger.error("解析长整形错误", e)
            null
        }
    }
}